/*****************************************************************************
 *                                                                           *
 * Program:  GeekCode for DOS and Windows                                    *
 *  Author:  Jeff Lee                                                        *
 *    Date:  begun 24 July 1995, finished 7 August 1995                      *
 * History:  17 Aug 1995 - Upgraded to version 3.1 of the Geek Code          *
 *                         (interim version; not released                    *
 *           14 Nov 1995 - BUGFIX: problem with @ directly after the code    *
 *           27 Mar 1996 - Add HTML output support (Mozilla 2.0 compliant)   *
 *           06 May 1996 - Fixed bug which failed to recognise G!            *
 *                                                                           *
 *****************************************************************************
 *                                                                           *
 *      WARNING: UGLY, UNCOMMENTED CODE AHEAD!  YOU HAVE BEEN WARNED!        *
 *                                                                           *
 *****************************************************************************
 *                                                                           *
 * This file is written so that it will compile under Borland's Turbo C++    *
 * AND Turbo C++ for Windows.  It should be compiled first as a DOS program  *
 * (medium model) and renamed to GEEKDOS.EXE.  The object files should then  *
 * be deleted, and the file should be recompiled as a Windows program.  The  *
 * Windows program will include GEEKDOS.EXE (which may be compressed first   *
 * with PKLITE) as the DOS program stub.  This means that the same           *
 * executable file may be used under both DOS and Windows.                   *
 *                                                                           *
 * So is that geeky, or what?                                                *
 *                                                                           *
 *****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <alloc.h>
#include <dos.h>

#define VERSION "1.14"

#ifdef _Windows

  #include <windows.h>
  #include <toolhelp.h>
  #include <shellapi.h>
  #include <commdlg.h>

  #define WM_QUERYDROPOBJECT 0x022B

#else

  #define FAR _far
  #define LPSTR char FAR *
  #define BOOL int
  #define CF_OEMTEXT 6
  #define CF_TEXT 7
  #define TRUE 1
  #define FALSE 0

#endif

#define cdi ClipData[index]
#define upcase(x) (((x >= 'a') && (x <= 'z')) ? x-32 : x)

BOOL hRegular( LPSTR token, char *bank[] );
BOOL hShape( LPSTR token, char *bank[] );
BOOL hUnix( LPSTR token, char *bank[] );
BOOL hSex( LPSTR token, char *bank[] );
BOOL OpenInputFile( void );
BOOL GetNextLine( LPSTR line, int maxlen );
void CloseInputFile( void );
void say( LPSTR what );
void PrepSay( void );
void PostSay( void );
int  Usage( void );
int  PrintError( char *foo );
void DoEvents( void );
void AddPending( LPSTR s, int confidence );

typedef struct tagPend { struct tagPend far *next;
                         LPSTR data;
                         int   confidence;
                       } PENDING, FAR *LPPENDING;

static char *codes[] =
  { "d", "s", "a", "C", "U", "P", "L", "E", "W", "N", "o", "K", "w",
    "O", "M", "V", "PS", "PE", "Y", "PGP", "t", "5", "X", "R",
    "tv", "b", "DI", "D", "G", "e", "h", "r", "x", "y", "z", "dpu", "" };  

#pragma warn -sus
BOOL (*handlers[])( LPSTR, char *[] ) =
  { hRegular, hShape, hRegular, hRegular, hUnix, hRegular, hRegular, hRegular, hRegular,
    hRegular, hRegular, hRegular, hRegular, hRegular, hRegular, hRegular, hRegular,
    hRegular, hRegular, hRegular, hRegular, hRegular, hRegular, hRegular, hRegular,
    hRegular, hRegular, hRegular, hRegular, hRegular, hRegular, hRegular, hSex, hSex, hSex,
    hRegular, NULL };
#pragma warn .sus

static char *cVocation[] = {
    "G",    "Vocation",
    "GB",  "Business",
    "GC",  "Classics",
    "GCA", "Commercial Arts",
    "GCM", "Computer Management",
    "GCS", "Computer Science",
    "GCC", "Communications",
    "GE",  "Engineering",
    "GED", "Education",
    "GFA", "Fine Arts",
    "GG",  "Government",
    "GH",  "Humanities",
    "GIT", "Information Technology",
    "GJ",  "Jurisprudence (Law)",
    "GLS", "Library Science",
    "GL",  "Literature",
    "GMC", "Mass Communications",
    "GM",  "Math",
    "GMD", "Medicine",
    "GMU", "Music",
    "GPA", "Performing Arts",
    "GP",  "Philosophy",
    "GS",  "Science (Physics, Chemistry, Biology, etc.)",
    "GSS", "Social Science (Psychology, Sociology, etc.)",
    "GTW", "Technical Writing",
    "GO",  "Other",
    "GU",  "'Undecided'",
    "GAT", "All Trades",
		"G!",  "no qualifications (a rather miserable existence, you would think)",
    "" };

static char *cAppearance[] = {
    "d",    "Appearance",
    "d++",  "I tend to wear conservative dress such as a business suit or worse, a tie.",
    "d+",   "Good leisure-wear. Slacks, button-shirt, etc. No jeans, tennis shoes, or t-shirts.",
    "d",    "I dress a lot like those found in catalog ads. Bland, boring, without life or meaning.",
    "d-",   "I'm usually in jeans and a t-shirt.",
    "d--",  "My t-shirts go a step further and have a trendy political message on them.",
    "d---", "Punk dresser, including, but not limited to, torn jeans and shirts, body piercings, and prominent tattoos.",
    "dx",   "Cross Dresser.",
    "d?",   "I have no idea what I am wearing right now, let alone what I wore yesterday.",
    "!d",   "No clothing. Quite a fashion statement, don't you think?",
    "dpu",  "I wear the same clothes all the time, no matter the occasion, forgetting to do laundry between wearings.",
    "" };

static char *cHeight[] = {  // requires special-case handler.
    "s",    "Height",
    "s+++", "I usually have to duck through doors.",
    "s++",  "I'm a basketball candidate.",
    "s+",   "I'm a little taller than most.",
    "s",    "I'm an average geek.",
    "s-",   "I look up to most people.",
    "s--",  "I look up to damn near everybody.",
    "s---", "I take a phone book with me when I go out so I can see to eat dinner.",
    "" };

static char *cWeight[] = {  // requires special-case handler.
    ":",    "Weight", 
    ":+++", "I take up three movie seats.",
    ":++",  "I'm a linebacker candidate.", 
    ":+",   "I'm a little rounder than most.",
    ":",    "I'm an average geek.",
    ":-",   "Everyone tells me to gain a few pounds.",
    ":--",  "I tend to have to fight against a strong breeze.",
    ":---", "My bones are poking through my skin.",
    "" };

static char *cAge[] = {  // requires special-case handler.
    "a",      "Age", 
    "a+++",   "60 and up.",
    "a++",    "50-59.",
    "a+",     "40-49.",
    "a",      "30-39.",
    "a-",     "25-29.",
    "a--",    "20-24.",
    "a---",   "15-19.",
    "a----",  "10-14.",
    "a-----", "9 and under (Geek in training?)",
    "a?",     "I am immortal.",
    "!a",     "It's none of your business how old I am.",
    "" };

static char *cComputers[] = {
    "C",     "Computers", 
    "C++++", "I'll be first in line to get the new cybernetic interface installed into my skull.",
    "C+++",  "You mean there is life outside of Internet?  You're shittin' me!  I haven't dragged myself to class in weeks.",
    "C++",   "Computers are a large part of my existence. When I get up in the morning, the first thing I do is log myself in. I play games or mud on weekends, but still manage to stay off of academic probation.",
    "C+",    "Computers are fun and I enjoy using them. I play a mean game of DOOM! and can use a word processor without resorting to the manual too often. I know that a 3.5\x22 disk is not a hard disk.  I also know that when it says 'press any key to continue', I don't have to look for a key labeled 'ANY'.",
    "C",     "Computers are a tool, nothing more. I use it when it serves my purpose.",
    "C-",    "Anything more complicated than my calculator and I'm screwed.",
    "C--",   "Where's the on switch?",
    "C---",  "If you even mention computers, I will rip your head off!",
    "" };

static char *cUnix[] = {  // requires special-case handler.
    "U",     "Unix", 
    "U++++", "I am the sysadmin. If you try and crack my machine don't be surprised if the municipal works department gets an \x22""accidental\x22 computer-generated order to put start a new landfill on your front lawn or your quota is reduced to 4K.",
    "U+++",  "I don't need to crack /etc/passwd because I just modified su so that it doesn't prompt me. The admin staff doesn't even know I'm here. If you don't understand what I just said, this category does NOT apply to you!",
    "U++",   "I've get the entire admin ticked off at me because I am always using all of the CPU time and trying to run programs that I don't have access to. I'm going to try cracking etc/passwd next week, just don't tell anyone.",
    "U+",    "I not only have a Unix account, but I slam VMS any chance I get.",
    "U",     "I have a Unix account to do my stuff in.",
    "U-",    "I have a VMS account.",
    "U--",   "I've seen Unix and didn't like it. DEC rules!",
    "U---",  "Unix geeks are actually nerds in disguise.",
    "" };

static char *cUnixCodes[] = {
    "x", "Unix Type",
    "B", "BSD",
    "L", "Linux",
    "U", "Ultrix",
    "A", "AIX",
    "V", "SysV",
    "H", "HPUX",
    "I", "IRIX",
    "O", "OSF/1 (aka Digital Unix)",
    "S", "Sun OS/Solaris",
    "C", "SCO Unix",
    "X", "NeXT",
    "*", "Some other one not listed",
    "" };

static char *cPerl[] = {
    "P",      "Perl",
    "P+++++", "I am Larry Wall, Tom Christiansen, or Randal Schwartz.",
    "P++++",  "I don't write Perl, I speak it. Perl has superseded all other programming languages. I firmly believe that all programs can be reduced to a Perl one-liner. I use Perl to achieve U+++ status.",
    "P+++",   "Perl is a very powerful programming tool. Not only do I no longer write shell scripts,  I also no longer use awk or sed. I use Perl for all programs of less than a thousand lines.",
    "P++",    "Perl is a powerful programming tool. I don't write shell scripts anymore because I write them in Perl.",
    "P+",     "I know of perl. I like perl. I just haven't learned much perl, but it is on my agenda.",
		"P",      "I know Perl exists, but that's all.",
		"P-",     "What's Perl got that awk and sed don't have?",
    "P--",    "Perl users are sick, twisted programmers who are just showing off.",
    "P---",   "Perl combines the power of sh, the clarity of sed, and the performance of awk with the simplicity of C. It should be banned.",
    "P?",     "What's Pearl?",
    "P!",     "Our paranoid admin won't let us install Perl!  Says it's a \x22""hacking tool\x22.",
    "" };

static char *cLinux[] = {
    "L",      "Linux",
    "L+++++", "I am Linus, grovel before me.",
    "L++++",  "I am a Linux wizard. I munch C code for breakfast and have enough room left over for a kernel debugging. I have so many patches installed that I lost track about ten versions ago. Linux newbies consider me a net.god.",
    "L+++",   "I use Linux exclusively on my system. I monitor comp.os.linux.* and even answer questions sometimes.",
    "L++",    "I use Linux ALMOST exclusively on my system. I've given up trying to achieve Linux.God status, but welcome the OS as a replacement for DOS. I only boot to DOS to play games.",
    "L+",     "I've managed to get Linux installed and even used it a few times. It seems like it is just another OS.",
    "L",      "I know what Linux is, but that's about all.",
    "L-",     "I have no desire to use Linux and frankly don't give a rats patootie about it. There are other, better, operating systems out there. Like Mac, DOS, or Amiga-OS. Or, better yet even, would be another free Unix OS like FreeBSD.",
    "L--",    "Unix sucks. Because Linux = Unix. Linux Sucks. I worship Bill Gates.",
    "L---",   "I am Bill Gates.",
    "!L",     "I don't even know what Linux is!",
    "" };

static char *cEmacs[] = {
    "E",     "Emacs", 
    "E+++",  "Emacs is my login shell!!  M-x doctor is my psychologist!  I use emacs to control my TV and toaster oven!  All you vi people don't know what you're missing!  I read alt.relgion.emacs, alt.sex.emacs, and comp.os.emacs.",
    "E++",   "I know and use elisp regularly!",
    "E+",    "Emacs is great! I read my mail and news with it!",
    "E",     "Yeah, I know what emacs is, and use it as my regular editor.",
    "E-",    "Emacs is too big and bloated for my tastes.",
    "E--",   "Emacs is just a fancy word processor.",
    "E---",  "Emacs sucks! vi forever!!!",
    "E----", "Emacs sucks! pico forever!!!",
    "" };

static char *cWeb[] = {
    "W",    "World Wide Web",
    "W+++", "I am a WebMaster. Don't even think about trying to view my homepage without the latest version of Netscape. When I'm not on my normal net connection, I surf the web using my Newton and a cellular modem.",
    "W++",  "I have a homepage. I surf daily. My homepage is advertised in my .signature.",
    "W+",   "I have the latest version of Netscape, and wander the web only when there's something specific I'm looking for.",
    "W",    "I have a browser and a connection. Occasionally I'll use them.",
    "W-",   "The web is really a pain. Life was so much easier when you could transfer information by simple ASCII. Now everyone won't even consider your ideas unless you spiff them up with bandwidth-consuming pictures and pointless information links.",
    "W--",  "A pox on the Web!  It wastes time and bandwidth and just gives the uneducated morons a reason to clutter the Internet.",
    "" };

static char *cUsenet[] = {
    "N",     "Usenet",
    "N++++", "I am Tim Pierce.",
    "N+++",  "I read so many news groups that the next batch of news comes in before I finish reading the last batch, and I have to read for about 2 hours straight before I'm caught up on the morning's news.  Then there's the afternoon...",
    "N++",   "I read all the news in a select handful of groups.",
    "N+",    "I read news recreationally when I have some time to kill.",
    "N",     "Usenet News?  Sure, I read that once.",
    "N-",    "News is a waste of my time and I avoid it completely.",
    "N--",   "News sucks!  'Nuff said.",
		"N---",  "I work for Time Magazine.",
    "N----", "I am a Scientologist.",
    "N*",    "All I do is read news.",
    "" };

static char *cOracle[] = {
		"o",      "Usenet Oracle",
    "o+++++", "I am Steve Kinzler",
    "o++++",  "I am an active Priest",
    "o+++",   "I was a Priest, but have retired.",
    "o++",    "I have made the Best Of Oracularities",
    "o+",     "I have been incarnated at least once.",
    "o",      "I've submitted a question, but it has never been incarnated.", 
    "o-",     "I sent my question to the wrong group and got flamed.",
		"o--",    "Who needs answers from a bunch of geeks anyhow?",
    "" };

static char *cKibo[] = {
    "K",       "Kibo",
    "K++++++", "I am Kibo.",
    "K+++++",  "I've had sex with Kibo.",
    "K++++",   "I've met Kibo.",
    "K+++",    "I've gotten mail from Kibo.",
    "K++",     "I've read Kibo.",
    "K+",      "I like Kibo.",
    "K",       "I know who Kibo is.",
    "K-",      "I don't know who Kibo is.",
    "K--",     "I dislike Kibo.",
    "K---",    "I am currently hunting Kibo down with the intent of ripping his still-beating heart out of his chest and showing it to him as he dies.",
    "K----",   "I am Xibo.",
    "" };

static char *cWindoze[] = {
    "w",      "Microsoft Windows",
    "w+++++", "I am Bill Gates.",
    "w++++",  "I have Windows, Windows 95, Windows NT, and Windows NT Advanced Server all running on my SMP RISC machine. I haven't seen daylight in six months.",
    "w+++",   "I am a MS Windows programming god. I wrote a VxD driver to allow MS Windows and DOS to share the use of my waffle iron. P.S. Unix sux.",
    "w++",    "I write MS Windows programs in C and think about using C++ someday. I've written at least one DLL.",
    "w+",     "I have installed my own custom sounds, wallpaper, and screen savers so my PC walks and talks like a fun house. Oh yeah, I have a hundred TrueType(tm) fonts that I've installed but never used.  I never lose Minesweeper and Solitaire.",
    "w",      "Ok, so I use MS Windows, I don't have to like it.",
    "w-",     "I'm still trying to install MS Windows and have at least one peripheral that never works right.",
    "w--",    "MS Windows is a joke operating system. Hell, it's not even an operating system. NT is Not Tough enough for me either. 95 is how may times it will crash an hour.",
    "w---",   "Windows has set back the computing industry by at least 10 years. Bill Gates should be drawn, quartered, hung, shot, poisoned, disembowelled, and then REALLY hurt.",
    "" };

static char *cOs2[] = {
    "O",     "OS/2",
    "O+++",  "I live, eat and breathe OS/2. All of my hard drives are HPFS. I am the Anti-Gates.",
    "O++",   "I use OS/2 for all my computing needs. I use some DOS and Windows programs, but run them under OS/2. If the program won't run under OS/2, then obviously I don't need it.",
    "O+",    "I keep a DOS partition on my hard drive \x22just in case\x22. I'm afraid to try HPFS.",
    "O",     "I finally managed to get OS/2 installed but wasn't too terribly impressed.",
    "O-",    "Tried it, didn't like it.",
    "O--",   "I can't even get the thing to install!",
    "O---",  "Windows RULES!!!  Long live Bill Gates.",
    "O----", "I am Bill Gates of Borg. OS/2 is irrelevant.",
    "" };

static char *cMacintosh[] = {
    "M",   "Macintosh",
    "M++", "I am a Mac guru. Anything those DOS putzes and Unix nerds can do, I can do better, and if not, I'll write the damn software to do it.",
    "M+",  "A Mac has its uses and I use it quite often.",
    "M",   "I use a Mac, but I'm pretty indifferent about it.",
    "M-",  "Macs suck. All real geeks have a character prompt.",
    "M--", "Macs do more than suck. They make a user stupid by allowing them to use the system without knowing what they are doing. Mac weenies have lower IQs than the fuzz in my navel.",
    "" };

static char *cVms[] = {
    "V",    "VMS",
    "V+++", "I am a VMS sysadmin. I wield far more power than those UNIX admins, because UNIX can be found on any dweeb's desktop. Power through obscurity is my motto.",
    "V++",  "Unix is a passing fad compared to the real power in the universe, my VMS system.",
    "V+",   "I tend to like VMS better than Unix.",
    "V",    "I've used VMS.",
    "V-",   "Unix is much better than VMS for my computing needs.",
    "V--",  "I would rather smash my head repeatedly into a brick wall than suffer the agony of working with VMS. It's reminiscent of a dead and decaying pile of moose droppings. Unix rules the universe.",
    "" };

static char *cPolitSocial[] = {
    "PS",    "Politics and Social Issues",
    "PS+++", "Legalize drugs!  Abolish the government. \x22""Fuck the draft!\x22",
    "PS++",  "I give to liberal causes. I march for gay rights. I'm a card carrying member of the ACLU. Keep abortion safe and legal.",
    "PS+",   "My whole concept of liberalism is that nobody has the right to tell anybody else what to do, on either side of the political fence. If you don't like it, turn the bloody channel.",
    "PS",    "I really don't have an opinion; nobody's messing with my freedoms right now.",
    "PS- ",  "Label records!  Keep dirty stuff off the TV and the Internet.",
    "PS--",  "Oppose sex education, abortion rights, gay rights. Rush Limbaugh is my spokesman.",
    "PS---", "Repent left-wing sinners and change your wicked evil ways. Buchanan/Robertson in '96.",
    "" };

static char *cPolitEcono[] = {
    "PE",    "Politics and Economic Issues",
    "PE+++", "Abolish antitrust legislation. Raise taxes on everyone but the rich so that the money can trickle-down to the masses.",
    "PE++",  "Keep the government off the backs of businesses. Deregulate as much as possible.",
    "PE+",   "Balance the budget with spending cuts and an amendment.",
    "PE",    "Distrust both government and business.",
    "PE-",   "It's ok to increase government spending, so we can help more poor people. Tax the rich!  Cut the defense budget!",
    "PE--",  "Capitalism is evil!  Government should provide the services we really need. Nobody should be rich.",
    "" };

static char *cCypherpunks[] = {
    "Y",    "Cypherpunks",
    "Y+++", "I am T.C. May.",
    "Y++",  "I am on the cypherpunks mailing list and active around Usenet. I never miss an opportunity to talk about the evils of Clipper and ITAR and the NSA. Orwells' 1984 is more than a story, it is a warning to ours and future generations. I'm a member of the EFF.",
    "Y+",   "I have an interest and concern in privacy issues, but in reality I am not really all that active or vocal.",
    "Y",    "I'm pretty indifferent on the whole issue.",
    "Y-",   "It seems to me that all of these concerns are a little extreme.  I mean, the government must be able to protect itself from criminals and the populace from indecent speech.",
    "Y--",  "Get a life. The only people that need this kind of protection are people with something to hide. I think cypherpunks are just a little paranoid.",
    "Y---", "I am L. Detweiler.",
    "" };

static char *cPgp[] = {
    "PGP",     "PGP",
    "PGP++++", "I am Philip Zimmerman.",
    "PGP+++",  "I don't send or answer mail that is not encrypted, or at the very least signed. If you are reading this without decrypting it first, something is wrong. IT DIDN'T COME FROM ME!",
    "PGP++",   "I have the most recent version and use it regularly.",
    "PGP+",    "\x22""Finger me for my public key.\x22",
    "PGP",     "I've used it, but stopped long ago.",
    "PGP-",    "I don't have anything to hide.",
    "PGP--",   "I feel that the glory of the Internet is in the anarchic, trusting environment that so nurtures the exchange of information. Encryption just bogs that down.",
    "PGP---",  "If you support encryption on the Internet, you must be a drug dealer or terrorist or something like that.",
    "PGP----", "Oh, here is something you all can use that is better (insert clipper here).",
    "" };

static char *cStarTrek[] = {
    "t",    "Star Trek",
    "t+++", "It's not just a TV show, it's a religion. I know all about warp field dynamics and the principles behind the transporter. I have memorized the TECH manual. I speak Klingon. I go to cons with Vulcan ears on. I have no life.",
    "t++",  "It's the best show around. I have all the episodes and the movies on tape and can quote entire scenes verbatim. I've built a few of the model kits too. But you'll never catch me at one of those conventions. Those people are kooks.",
    "t+",   "It's a damn fine TV show and is one of the only things good on television any more.",
    "t",    "It's just another TV show.",
    "t-",   "Maybe it is just me, but I have no idea what the big deal with Star Trek is. Perhaps I'm missing something but I just think it is bad drama.",
    "t--",  "Star Trek is just another Space Opera. William Shatner isn't an actor, he's a poser!  And what's with this Jean-Luc Picard?  A Frenchman with a British accent?  Come on. I'd only watch this show if my remote control broke. Isn't Voyager just a rehash of Lost in Space?  Has Sisko even breathed in the last two seasons?",
    "t---", "Star Trek SUCKS!  It is the worst crap I have ever seen! Hey, all you trekkies out there, GET A LIFE!  (William Shatner is a t---)",
		"t*",   "I identify with Barclay, the greatest of the Trek Geeks.",
    "" };

static char *cBabylon5[] = {
    "5",     "Babylon 5",
    "5++++", "I am J. Michael Straczynski",
    "5+++",  "I am a True Worshipper of the Church of Joe who lives eats breathes and thinks Babylon 5, and has Evil thoughts about stealing Joe's videotape archives just to see episodes earlier. I am planning to break into the bank and steal the triple-encoded synopsis of the 5-year arc.",
    "5++",   "Finally a show that shows what a real future would look like. None of this Picardian \x22Let's talk about it and be friends\x22 crap. And what's this?  We finally get to see a bathroom!  Over on that Enterprise, they've been holding it for over seven years!",
    "5+",    "Babylon 5 certainly presents a fresh perspective in the Sci-Fi universe. I watch it weekly.",
    "5",     "I've seen it, I am pretty indifferent to it.",
    "5-",    "This show is sub-par. The acting is wooden, the special effects are obviously poor quality. In general, it seems like a very cheap Star Trek ripoff.",
    "5--",   "You call this Sci-Fi?  That is such a load of crap!  This show is just a soap with bad actors, piss-poor effects, and lame storylines. Puh-leese.",
    "" };

static char *cXfiles[] = {
    "X",     "The X-Files",
    "X++++", "I am Chris Carter.",
    "X+++",  "This is the BEST show on TV, and it's about time. I've seen everything David Duchovny and Gillian Anderson have ever done that been recorded and I'm a loyal Duchovny/Gillian Anderson fan. I've Converted at least 10 people. I have every episode at SP, debate the fine details on-line, and have a credit for at least 2 YAXAs.",
    "X++",   "This is one of the better shows I've seen. I wish I'd taped everything from the start at SP, because I'm wearing out my EP tapes. I'll periodically debate online. I've Converted at least 5 people. I've gotten a YAXA.",
    "X+",    "I've Converted my family and watch the show when I remember. It's really kinda fun.",
    "X",     "Ho hum. Just another Fox show.",
    "X-",    "It's ok if you like paranoia and conspiracy stories, but, let's face it, it's crap.",
    "X--",   "If I wanted to watch this kind of stuff, I'd talk to Oliver Stone.",
    "" };

static char *cRolePlaying[] = {
    "R",    "Role Playing",
    "R+++", "I've written and published my own gaming materials.",
    "R++",  "There is no life outside the role of the die. I know all of the piddly rules of (chosen game). _MY_ own warped rules scare the rest of the players.",
    "R+",   "I've got my weekly sessions set up and a character that I know better than I know myself.",
    "R",    "Role-Playing?  That's just something to do to kill a Saturday afternoon.",
    "R-",   "Gosh, what an utter waste of time!",
    "R--",  "Role-Players are instruments of pure evil.",
    "R---", "I work for T$R.",
    "R*",   "I thought life WAS role-playing?",
    "" };

static char *cTelevision[] = {
    "tv",    "Television",
    "tv+++", "There's nothing I can experience \x22out there\x22 that I can't see coming over my satellite dish. I wish there were MORE channels. I live for the O.J. Trial.",
    "tv++",  "I just leave the tv on, to make sure I don't miss anything.",
    "tv+",   "I watch some tv every day.",
    "tv",    "I watch only the shows that are actually worthwhile, such as those found on PBS.",
    "tv-",   "I watch tv for the news and 'special programming.'",
    "tv--",  "I turn my tv on during natural disasters.",
    "!tv",   "I do not own a television.",
    "" };

static char *cBooks[] = {
    "b",     "Books",
		"b++++", "I read a book a day. I have library cards in three states. I have discount cards from every major bookstore. I've ordered books from another country to get my Favorite Author Fix.",
    "b+++",  "I consume a few books a week as part of a staple diet.",
    "b++",   "I find the time to get through at least one new book a month.",
    "b+",    "I enjoy reading, but don't get the time very often.",
    "b",     "I read the newspaper and the occasional book.",
    "b-",    "I read when there is no other way to get the information.",
    "b--",   "I did not actually READ the geek code, I just had someone tell me.",
    "" };

static char *cDilbert[] = {
    "DI",      "Dilbert",
    "DI+++++", "I am Scott Adams.",
    "DI++++",  "I've received mail from Scott Adams. I'm in the DNRC (Dogbert's New Ruling Class).",
    "DI+++",   "I am a Dilbert prototype.",
    "DI++",    "I work with people that act a lot like Dilbert and his boss.",
    "DI+",     "I read Dilbert daily, often understanding it.",
    "DI",      "I read Dilbert infrequently, rarely understanding it.",
    "DI-",     "Is that the comic about the engineers?",
    "DI--",    "Don't read it, but I think the dog is kinda cute.",
    "DI---",   "I don't think it's funny to make fun of managers trying their best to run their organizational units.",
    "" };

static char *cDoom[] = {
    "D",     "DOOM!",
    "D++++", "I work for iD Software.",
    "D+++",  "I crank out PWAD files daily, complete with new monsters, weaponry, sounds and maps. I'm a DOOM God. I can solve the original maps in nightmare mode with my eyes closed.",
    "D++",   "I've played the shareware version and bought the real one and I'm actually pretty good at the game. I occasionally download PWAD files and play them too.",
    "D+",    "It's a fun, action game that is a nice diversion on a lazy afternoon.",
    "D",     "I've played the game and I'm pretty indifferent.",
    "D-",    "I've played the game and really didn't think it was all that impressive.",
    "D--",   "It's an overly-violent game and pure crap.",
    "D---",  "To hell with Doom, I miss Zork.",
    "D----", "I've seen better on my Atari 2600",
    "" };

static char *cGeekCode[] = {
    "G",      "The Geek Code",
    "G+++++", "I am Robert Hayden.",
		"G++++",  "I have made a suggestion for future versions of the code.", 
    "G+++",   "I have memorized the entire geek code, and can decode others' codes in my head. I know by heart where to find the current version of the code on the net.",
    "G++",    "I know what each letter means, but sometimes have to look up the specifics.",
    "G+",     "I was once G++ (or higher), but the new versions are getting too long and too complicated.",
    "G",      "I know what the geek code is and even did up this code.",
    "G-",     "What a tremendous waste of time this Geek Code is.",
    "G--",    "Not only a waste of time, but it obviously shows that this Hayden guy needs a life.",
    "" };

static char *cEducation[] = {
    "e",      "Education",
    "e+++++", "I am Stephen Hawking.",
    "e++++",  "Managed to get my Ph.D.",
    "e+++",   "Got a Masters degree.",
    "e++",    "Got a Baccalaureate degree.",
    "e+",     "Got an Associate degree.",
    "e",      "Finished High School.",
    "e-",     "Haven't finished High School.",
    "e--",    "Haven't even entered High School.",
    "e*",     "I learned everything there is to know about life from the \x22Hitchhiker's Trilogy\x22.",
    "" };

static char *cHousing[] = {
    "h",     "Housing",
    "h++",   "Living in a cave with 47 computers and an Internet feed, located near a Dominoes pizza. See !d.",
    "h+",    "Living alone, get out once a week to buy food, no more than once a month to do laundry. All surfaces covered.",
    "h",     "Friends come over to visit every once in a while to talk about Geek things. There is a place for them to sit.",
    "h-",    "Living with one or more registered Geeks.",
    "h--",   "Living with one or more people who know nothing about being a Geek and refuse to watch Babylon 5.",
    "h---",  "Married, or living romantically with someone.",
    "h----", "Married with children - Al Bundy can sympathize.",
    "h!",    "I am stuck living with my parents!",
    "h*",    "I'm not sure where I live anymore. This lab/workplace seems like home to me.",
    "" };

static char *cRelationships[] = {
    "r",    "Relationships",
    "r+++", "Found someone, dated, and am now married.",
    "r++",  "I've dated my current S.O. for a long time.",
    "r+",   "I date frequently, bouncing from one relationship to another.",
    "r",    "I date periodically.",
    "r-",   "I have difficulty maintaining a relationship.",
    "r--",  "People just aren't interested in dating me.",
    "r---", "I'm beginning to think that I'm a leper or something, the way people avoid me like the plague.",
    "!r",   "I've never had a relationship.",
    "r*",   "signifying membership in the SBCA (Sour Bachelor(ette)'s Club of America). The motto is 'Bitter, but not Desperate'. First founded at Caltech.",
    "r%",   "I was going out with someone, but the asshole dumped me.",
    "" };

static char *cSexx[] = { // requires special-case handler
    "x",      "Sex",
    "x+++++", "I am Madonna.",
    "x++++",  "I have a few little rug rats to prove I've been there. Besides, with kids around, who has time for sex?",
    "x+++",   "I'm married, so I can get it (theoretically) whenever I want.",
    "x++",    "I was once referred to as 'easy'. I have no idea where that might have come from though.",
    "x+",     "I've had real, live sex.",
    "x",      "I've had sex. Oh!  You mean with someone else?  Then no.",
    "x-",     "Not having sex by choice.",
    "x--",    "Not having sex because I just can't get any...",
    "x---",   "Not having sex because I'm a nun or a priest.",
    "x*",     "I'm a pervert.",
    "x**",    "I've been known to make perverts look like angels.",
    "!x",     "Sex?  What's that?  I've had no sexual experiences.",
    "x?",     "It's none of your business what my sex life is like.",
    "!x+",    "Sex? What's that? No experience, willing to learn!",
    "" };

static char *cSexy[] = { // requires special-case handler
    "y",      "Sex",
    "y+++++", "I would be Madonna, except I'm male.",
    "y++++",  "I have a few little rug rats to prove I've been there. Besides, with kids around, who has time for sex?",
    "y+++",   "I'm married, so I can get it (theoretically) whenever I want.",
    "y++",    "I was once referred to as 'easy'. I have no idea where that might have come from though.",
    "y+",     "I've had real, live sex.",
    "y",      "I've had sex. Oh!  You mean with someone else?  Then no.",
    "y-",     "Not having sex by choice.",
    "y--",    "Not having sex because I just can't get any...",
    "y---",   "Not having sex because I'm a nun or a priest.",
    "y*",     "I'm a pervert.",
    "y**",    "I've been known to make perverts look like angels.",
    "!y",     "Sex?  What's that?  I've had no sexual experiences.",
    "y?",     "It's none of your business what my sex life is like.",
    "!y+",    "Sex? What's that? No experience, willing to learn!",
    "" };

static char *cSexz[] = { // requires special-case handler
    "z",      "Sex",
    "z+++++", "I might be Madonna, but I'm not disclosing my gender.",
    "z++++",  "I have a few little rug rats to prove I've been there. Besides, with kids around, who has time for sex?",
    "z+++",   "I'm married, so I can get it (theoretically) whenever I want.",
    "z++",    "I was once referred to as 'easy'. I have no idea where that might have come from though.",
    "z+",     "I've had real, live sex.",
    "z",      "I've had sex. Oh!  You mean with someone else?  Then no.",
    "z-",     "Not having sex by choice.",
    "z--",    "Not having sex because I just can't get any...",
    "z---",   "Not having sex because I'm a nun or a priest.",
    "z*",     "I'm a pervert.",
    "z**",    "I've been known to make perverts look like angels.",
    "!z",     "Sex?  What's that?  I've had no sexual experiences.",
    "z?",     "It's none of your business what my sex life is like.",
    "!z+",    "Sex? What's that? No experience, willing to learn!",
    "" };

static char HTMLHeader[] =
    "<html>\xd\xa"
    "  <head>\xd\xa"
    "    <title>\xd\xa"
    "      Expanded Geek Code\xd\xa"
    "    </title>\xd\xa"
    "  </head>\xd\xa\xd\xa"
    "  <body>\xd\xa"
    "    <center>\xd\xa"
    "      <font size=7>Expanded Geek Code</font><br>\xd\xa"
    "      Expanded by the Official DOS/Windows \xd\xa"
    "      <a href=\x22""http://krypton.mankato.msus.edu/~hayden/geek.html\x22"">\xd\xa"
    "      Geek Code</a> Decoder (v" VERSION ")<br>\xd\xa"
    "      by <a href=\x22""http://www.gate.net/~shipbrk\x22"">Jeff Lee</a>\xd\xa"
    "      <br>\xd\xa"
    "      <br>\xd\xa";

static char HTMLFooter[] =
    "  </body>\xd\xa"
    "</html>\xd\xa";


char **banks[] =
  { cAppearance, cHeight, cAge, cComputers, cUnix, cPerl, cLinux, cEmacs, cWeb, cUsenet,
		cOracle, cKibo, cWindoze, cOs2, cMacintosh, cVms, cPolitSocial, cPolitEcono,
		cCypherpunks, cPgp, cStarTrek, cBabylon5, cXfiles, cRolePlaying, cTelevision, cBooks,
		cDilbert, cDoom, cGeekCode, cEducation, cHousing, cRelationships, cSexx, cSexy, cSexz,
    cAppearance, NULL }; 

LPPENDING root = NULL;
LPPENDING tail = NULL;
LPSTR     ClipData = 0;
BOOL      UseClipboard = FALSE, UseStdin = FALSE, Parsing = FALSE, PrintAll = FALSE;
BOOL      foundone, HTML = FALSE, CodesFound = FALSE, NotHeader = TRUE;
char      InFileName[144];
long      index = 0;
int       InvalidTokens = 0;

#ifdef _Windows

  HINSTANCE inst = NULL;
  DLGPROC   TextProc = NULL;
  HICON     MainIcon = NULL;
  HWND      MainWindow = NULL, TextWindow = NULL, TopWindow = NULL;
  BOOL      HelpCalled = FALSE;

#else

  FILE      *infile = NULL;
  BOOL      WrapText = TRUE;

#endif


BOOL CharInString( char c, char *s )
{
  int i = 0;
  while (s[i]) if (s[i++] == c) return TRUE;
  return FALSE;
}

#pragma warn -par
#pragma warn -rvl

BOOL hRegular( LPSTR token, char *bank[] )
{
  char foo[100], bar[100], tempbank[1024], savechar, lastchar = 0;
  BOOL result = TRUE, quit, integers = FALSE;
  int i = 0, j, l, t, k, integer = 0, LastNumber;

  tempbank[0] = 0;
  if (HTML) _fstrcpy( tempbank, "    <strong>" );
  _fstrcat( tempbank, bank[1] );
  _fstrcat( tempbank, ": " );
  if (HTML) _fstrcat( tempbank, "</strong>" );

  while ((token[i]) && (result))
  {
    integers = FALSE;
    j = l = integer = 0;
    savechar = 0;
    if (token[i] == '!') foo[j++] = token[i++];
    while ((token[i]) && (token[i] == bank[0][l])) { i++; l++; }
    foo[j] = 0;
    strcat( foo, bank[0] );
    j = strlen( foo );
    k = j;
    for (quit = FALSE; !quit;)
    {
      if ((bank[0][0] == 'd') && (token[i] == 'p') && (token[i+1] == 'u') && (k == j))
      {
        foo[j++] = token[i++];
        foo[j++] = token[i++];
        quit = TRUE;
      }
      else
      {
        if ((!token[i]) || (CharInString( token[i], "@()>$?" )))
          quit = TRUE;
        else
        {
          if (CharInString( token[i], "0123456789" ))
          {
            integers = TRUE;
            integer = (integer*10) + (token[i++] - '0');
          }
          else
          {
            if ((j != k) && (token[i] != foo[j-1]))
              quit = TRUE;
            else
              foo[j++] = token[i++];
          }
        }
      }
    }
    foo[j] = 0;

    switch (token[i])
    {
      case  0  : break;
      case '+' :
      case '-' :
      case 'p' :
      case '*' : i--; break;
      case '@' :
      case '(' :
      case ')' :
      case '>' :
      case '$' :
      case '?' :
        savechar = token[i];
        break;
      default : return FALSE;
    }
    if (token[i]) i++;

    foundone = FALSE;
    if (!integers)
    {
      t = 2;
      while (bank[t][0])
      {
        if (!_fstrcmp( foo, bank[t] ))
        {
          if (((!lastchar) || (LastNumber != t)) &&
              ((!CharInString( savechar, "?" )) || (j != k)))   // was "@$?"
          {
            if (lastchar == '>') _fstrcat( tempbank, "  (Striving towards \x22" );
            if (!CharInString( lastchar, ")@$?!*" ))
              _fstrcat( tempbank, bank[t+1] );
						if (lastchar == '>')
						{
							if (tempbank[_fstrlen(tempbank)-1] == ' ') tempbank[_fstrlen(tempbank)-1] = 0;
							_fstrcat( tempbank, "\x22) " );
            }
            _fstrcat( tempbank, " " );
          }
          LastNumber = t;
          lastchar = 0;
          foundone = TRUE;
        }
        t += 2;
      }
    }
    if ((!foundone) && (foo[0] == '!'))
    {
      _fstrcat( tempbank, " I refuse to participate in this category. " );
      foundone = TRUE;
    }

    if ((!foundone) && (integers))
    {
      char tempnum[10];

      sprintf( tempnum, "%d. ", integer );
      _fstrcat( tempbank, tempnum );
      foundone = TRUE;
    } 

    if (savechar)
    {
      foundone = FALSE;
      _fstrcpy( foo, bank[0] );
      j = _fstrlen( foo );
      foo[j++] = savechar;
      foo[j] = 0;
      t = 2;
      while (bank[t][0])
      {
        if (!_fstrcmp( foo, bank[t] ))
        {
          _fstrcat( tempbank, bank[t+1] );
          foundone = TRUE;
        }
        t += 2;
      }
      if (!foundone)
      {
        switch (savechar)
        {
          case '@' : foundone = TRUE; lastchar = '@'; _fstrcat( tempbank, " (This trait may change with time or individual interaction.) " );  break;
          case '(' : foundone = TRUE; _fstrcat( tempbank, " (Ranges to \x22" );  break;
					case ')' : foundone = TRUE;
										 if (tempbank[_fstrlen(tempbank)-1] == ' ')
										   tempbank[_fstrlen(tempbank)-1] = 0;
										 _fstrcat( tempbank, "\x22) " );  lastchar = ')';
										 break;
          case '>' : foundone = TRUE;
                     if (token[i] == '$')
                     {
                       i++;
                       _fstrcat( tempbank, " I want to make money doing this and/or do this for a living. " );
                     }
                     lastchar = '>';
                     break;
          case '$' : foundone = TRUE; lastchar = '$'; _fstrcat( tempbank, " I do this for a living. " );  break;
          case '?' : foundone = TRUE; lastchar = '?'; _fstrcat( tempbank, " I don't know anything about it. " );  break;
        }
      } 
    }
    if (!foundone) result = FALSE;
  }
  if ((result) && (lastchar == '>'))
  {
    _fstrcpy( foo, bank[0] );
    t = 2;
    while (bank[t][0])
    {
      if (!_fstrcmp( foo, bank[t] ))
      {
        if (LastNumber != t)
        {
          if (lastchar == '>') _fstrcat( tempbank, " (Striving towards \x22" );
          _fstrcat( tempbank, bank[t+1] );
					if (lastchar == '>')
					{
						if (tempbank[_fstrlen(tempbank)-1] == ' ') tempbank[_fstrlen(tempbank)-1] = 0;
						_fstrcat( tempbank, "\x22) " );
					}
        }
        foundone = TRUE;
      }
      t += 2;
    }
  }
  if (HTML) _fstrcat( tempbank, "<br>\xd\xa    <br>" );
  if (result) AddPending( tempbank, 100 / (InvalidTokens+1) );
  return result;
}

BOOL hShape( LPSTR token, char *bank[] )
{
  LPSTR height = (LPSTR) farmalloc( _fstrlen( token ) + 1 );
  LPSTR weight = (LPSTR) farmalloc( _fstrlen( token ) + 1 );
  int i, h, w;
  BOOL result = TRUE, modifiers = FALSE, foundColon = FALSE;

  i = h = w = 0;
  if (token[i] == '!') height[h++] = weight[w++] = token[i++] = '!';
  if (token[i] == 's') i++;
  height[h++] = 's';  weight[w++] = ':';
  while (token[i])
  {
    while ((token[i]) && (token[i] != ':'))
    {
      if (CharInString( token[i], "?@()>" )) modifiers = TRUE; 
      height[h++] = token[i++];
    }
    if ((foundColon = (token[i] == ':')) != FALSE)
    {
      i++;
      if (modifiers)
        while (token[i]) weight[w++] = token[i++];
      else
      {
        while ((token[i]) && (!CharInString( token[i], "()>" ))) weight[w++] = token[i++];
        while ((token[i]) && (CharInString( token[i], "()>" ))) weight[w++] = height[h++] = token[i++];
      }
    }
  }
  height[h] = weight[w] = 0;

  result = hRegular( height, cHeight );
  if (result)
  {
    if (foundColon)
      result = hRegular( weight, cWeight );
    else
			AddPending( HTML ? "    <strong>Weight: </strong>(Undisclosed)<br>/xd/xa    <br>" : "Weight: (Undisclosed)", 75 );
  }

  farfree( height );
  farfree( weight );
  return result;
}

BOOL hUnix( LPSTR token, char *bank[] )
{
  LPSTR foo = (LPSTR) farmalloc( _fstrlen( token ) + 1 );
  LPSTR bar = (LPSTR) farmalloc( 255 );
  int i = 0, j = 0, k = 0;
  BOOL result = TRUE; 

  if (token[i] == '!') foo[j++] = token[i++];
  foo[j++] = token[i++];
  while (CharInString( token[i], "BLUAVHIOSCX*" )) bar[k++] = token[i++];
  while (token[i]) foo[j++] = token[i++];
  foo[j] = bar[k] = 0;
  if (hRegular( foo, bank ))
  {
    if (bar[0])
    {
      LPSTR baz = (LPSTR) farmalloc( 1024 );
      baz[0] = 0;
      if (HTML) _fstrcat( baz, "    <strong>" );
      _fstrcat( baz, "Unix type" );
      if (bar[1]) _fstrcat( baz, "s" );
      _fstrcat( baz, " used: " );
      if (HTML) _fstrcat( baz, "</strong>" );
      i = 0;
      while ((bar[i]) && (result))
      {
        if (i)
        {
          if (bar[i+1])
            _fstrcat( baz, ", " );
          else
            _fstrcat( baz, " and " );
        }
        j = 2;
        while ((cUnixCodes[j][0]) && (cUnixCodes[j][0] != bar[i])) j += 2;
        if (cUnixCodes[j][0])
        {
          _fstrcat( baz, cUnixCodes[j+1] ); 
        }
        else result = FALSE;
        i++;  
      }
      if (HTML) _fstrcat( baz, "<br>\xd\xa    <br>" );
      if (result) AddPending( baz, 100 );
      farfree( baz );
    }
  } else result = FALSE;
  farfree( foo );
  farfree( bar );
  return result;
}

BOOL hSex( LPSTR token, char *bank[] )
{
  if (hRegular( token, bank ))
  {
    LPSTR Gender = farmalloc( 256 );
    Gender[0] = 0;

    if (HTML) _fstrcat( Gender, "    <strong>" );
    _fstrcat( Gender, "Gender: " );
    if (HTML) _fstrcat( Gender, "</strong>" );

    switch (bank[0][0])
    {
      case 'x' : _fstrcat( Gender, "female" );  break;
      case 'y' : _fstrcat( Gender, "male" );  break;
      case 'z' : _fstrcat( Gender, "undisclosed" );  break;
    }

    if (HTML) _fstrcat( Gender, "<br>\xd\xa    <br>" );
    AddPending( Gender, 100 );
    farfree( Gender );
    return TRUE;
  }
  else return FALSE;
}

#pragma warn .par
#pragma warn .rvl

void trim( LPSTR s )
{
  LPSTR foo = (LPSTR) farmalloc( _fstrlen( s ) + 1 );
  int i = 0;
  while ((s[i] == 32) || (s[i] == 9)) i++;
  _fstrcpy( foo, &s[i] );
  i = _fstrlen( foo );
  while ((foo[i-1] == 32) || (foo[i-1] == 9)) foo[--i] = 0;
  _fstrcpy( s, foo );
  farfree( foo );
}

void AddPending( LPSTR s, int confidence )
{
  LPPENDING temp = (LPPENDING) farmalloc( sizeof( PENDING ));

  temp->data = (LPSTR) farmalloc( _fstrlen( s ) + 1 );
  _fstrcpy( temp->data, s );
  temp->confidence = confidence;
  temp->next = NULL;
  if (root)
    tail = tail->next = temp;
  else
    root = tail = temp;
}

void PrintPending( void )
{
  LPPENDING temp = root;

  if (temp)
  {
    while (temp)
    {
      say( temp->data );
      say( "" );
      temp = temp->next;
    }
    CodesFound = TRUE;
  }
  else
    say( "*** No codes found ***" );
}

int FindHighestConfidence( void )
{
  int CurLine = 0, LastLine = 0, ThisLine = 0, Total = 0, NumLines = 0, foo, Highest = 0;
  LPPENDING temp = root;

  if (!temp) return -1;
  while (temp)
  {
    if (temp->confidence < 0)
    {
      foo = Total / NumLines;
      if (NumLines <= 10) foo /= ((10-NumLines)+1);

      if (foo > Highest)
      {
        Highest = foo;
        LastLine = CurLine;
      }
      NumLines = Total = 0;
      CurLine = ThisLine+1;
    }
    else
    {
      Total += temp->confidence;
      NumLines++;
    }
    temp = temp->next; ThisLine++;
  }

  foo = Total / NumLines;
  if (NumLines <= 10) foo /= ((10-NumLines)+1);
  if (foo > Highest) LastLine = CurLine;
  return LastLine;
}

void PrintHighestConfidence( int StartingLine )
{
  LPPENDING temp = root;
  int i;

  if (StartingLine < 0)
  {
    say( "*** No codes found ***" );
    return;
  }
  for (i = 0; i < StartingLine; i++) if (temp) temp = temp->next;
  if (temp)
  {
    while ((temp) && (temp->confidence >= 0))
    {
      CodesFound = TRUE;
      say( temp->data );
      say( "" );
      temp = temp->next;
    }
  }

}

void KillPending( void )
{
  LPPENDING temp;

  while (root)
  {
    temp = root;
    root = root->next;
    if (temp->data) farfree( temp->data );
    farfree( temp );
  }
}

int GetTokenNumber( LPSTR token, char *bank[] )
{
  int i = 2;

  while (bank[i][0])
  {
    if (!_fstrcmp( token, &bank[i][0] )) return i;
    i+=2;
  }
  return 0;
}

BOOL ParseArgs( void )
{
  int i, j = _argc, k;
  char foo[255];
  BOOL result = TRUE;

  InFileName[0] = 0;
  for (i = 1; i < j; i++)
  {
    strcpy( foo, _argv[i] );
    if ((foo[0] == '/') || (foo[0] == '-'))
    {
      k = 1;
      while (foo[k])
      {
        switch (foo[k])
        {
          case 'c' : UseClipboard = TRUE;   break;
          case 'a' : PrintAll     = TRUE;   break;
          case 'h' : PrintAll     = FALSE;  break;
          case 't' : HTML         = FALSE;  break;
          case 'm' : HTML         = TRUE;   break;
#ifndef _Windows
          case 'w' : WrapText     = TRUE;   break;
          case 'n' : WrapText     = FALSE;  break;
#endif
          default  : result = FALSE;
        }
        k++;
      }
    }
    else
    {
      if (InFileName[0]) result = FALSE;
      _fstrcpy( InFileName, _argv[i] );
    }
  }
  if (!InFileName[0]) UseStdin = TRUE;
  return result;
}

BOOL GetToken( LPSTR token, LPSTR line )
{
  int i = 0, linelen = _fstrlen( line );
  LPSTR temp1 = (LPSTR) farmalloc( linelen + 1 );
  LPSTR temp2 = (LPSTR) farmalloc( linelen + 1 );
  temp1[0] = 0;
  _fstrcpy( temp2, line );
  trim( temp2 );
  while ((temp2[i] != 32) && (temp2[i] != 9) && (temp2[i])) i++;
  _fstrncpy( token, temp2, i );
  token[i] = 0;
  _fstrcpy( temp1, &temp2[i] );
  trim( temp1 );
  _fstrcpy( line, temp1 );
  farfree( temp1 );
  farfree( temp2 );
  return (token[0] != 0);
}

BOOL CheckGeekInitString( LPSTR token )
{
  BOOL result = FALSE;

  if (token[0] == 'G')
  {
    int count = 0, i = 1, j, k, toklen = _fstrlen( token );
    LPSTR token1 = (LPSTR) farmalloc( toklen + 1 );
    LPSTR expanded = (LPSTR) farmalloc( 1024 );
    BOOL quit = FALSE;

    expanded[0] = token1[1] = 0;
    while (!quit)
    {
      token1[0] = 'G';
      if (token[i] == 'G') i++;
      j = 1;  k = 0;
      while ((token[i] == '!') || ((token[i] >= 'A') && (token[i] <= 'Z'))) token1[j++] = token[i++];
      token1[j] = 0;
      switch (token[i])
      {
        case 0 :
          if (token1[1])
          {
            if ((k = GetTokenNumber( token1, cVocation )) != 0)
            {
              result = TRUE;
              count++;
            }
            else
            {
              LPSTR token2 = (LPSTR) farmalloc( _fstrlen( token1 ) + 2 );
              token2[0] = 'G';
              _fstrcpy( &token2[1], token1 );
              if ((k = GetTokenNumber( token2, cVocation )) != 0)
              {
                result = TRUE;
                count++;
              } else result = FALSE;
            }
          }
          quit = TRUE;
          break;

        case '{' :
        case '}' :
        case '/' :
        case '|' :
        case '.' :
        case '(' :
        case ')' :
        case ',' :
          if (token1[1])
          {
            k = GetTokenNumber( token1, cVocation );
            if (k >= 0)
            {
              result = TRUE;
              count++;
            } else
            {
              LPSTR token2 = (LPSTR) farmalloc( _fstrlen( token1 ) + 2 );
              token2[0] = 'G';
              _fstrcpy( &token2[1], token1 );
              if ((k = GetTokenNumber( token2, cVocation )) != 0)
              {
                result = TRUE;
                count++;
              }
              else
              {
                quit = TRUE;
                result = FALSE;
              }
            }
          }
          i++;
          break;

        default :
          quit = TRUE;
          result = FALSE;
      }
      if (k)
      {
        if (!expanded[0])
        {
          _fstrcpy( expanded, HTML ? "      <font size=5>\xd\xa        Geek of " : "Geek of " );
        }
        else
          {
            if (token[i])
              _fstrcat( expanded, ", " );
            else
            {
              _fstrcat( expanded, " and " );
            }
          }
        _fstrcat( expanded, cVocation[k+1] );
      }
    }
    farfree( token1 );
    if (!count) result = FALSE;
    if (!expanded[0]) result = FALSE;
    if (result)
    {
      NotHeader = FALSE;
      if (HTML) say( HTMLHeader );
      NotHeader = TRUE;
      _fstrcat( expanded, "." );
      if (HTML) _fstrcat( expanded, "\xd\xa      </font>\xd\xa    </center>\xd\xa    <br>" );
      if (root) AddPending( HTML ? "    <hr>" : "-----", -1 );

      AddPending( expanded, 100 );
    }
    farfree( expanded );
  }
  return result;
}

BOOL CheckRegularToken( LPSTR token )
{
  char c[10];
  int i = (token[0] == '!') ? 1 : 0, j = 0;
  BOOL quit = FALSE, result = FALSE, letters = FALSE;

  while ((j < 9) && (((upcase(token[i]) >= 'A') && (upcase(token[i]) <= 'Z')) ||
         ((!letters) && (token[i] >= '0')) && (token[i] <= '9')))
  {
    if ((token[i] < '0') || (token[i] >= '9')) letters = TRUE;
    c[j++] = token[i++];
  }
  c[j] = 0;
  i = 0;
  while (!quit)
  {
    if (!codes[i][0]) quit = TRUE;
    else
    {
      if (c[0] == 'U')
      {
        result = hUnix( (LPSTR) token, cUnix );
        quit = TRUE;
      }
      else if (!_fstrcmp( c, codes[i] ))
      {
        result = handlers[i]( (LPSTR) token, banks[i] );
        quit = TRUE;
      }
    }
    i++;
  }
  return result;
}

void GoToTown( void )
{
  LPSTR foo = (LPSTR) farmalloc( 1024 );
  LPSTR token = (LPSTR) farmalloc( 1024 );
  int EmptyLines = 0;
  BOOL TokenOnThisLine;

  Parsing = FALSE;
  InvalidTokens = 0;
  PrepSay();
  while (GetNextLine( foo, 1024 ))
  {
    TokenOnThisLine = FALSE;
    while (GetToken( token, foo ))
    {
      if ((token[0] == 'G') && (CheckGeekInitString( token )))
      {
        Parsing = TRUE;
        TokenOnThisLine = TRUE;
      }
      else
      {
        if (Parsing)
        {
          if (CheckRegularToken( token ))
          {
            InvalidTokens = 0;
            TokenOnThisLine = TRUE;
          }
          else
            InvalidTokens++;
        }
      }
      DoEvents();
    }
    DoEvents();
    EmptyLines = (TokenOnThisLine) ? 0 : EmptyLines +1;
    if (EmptyLines >= 2) Parsing = FALSE;
  }
  CodesFound = FALSE;
  if (PrintAll)
    PrintPending();
  else
    PrintHighestConfidence( FindHighestConfidence());
  KillPending();
  if ((CodesFound) && (HTML)) say( HTMLFooter );
  PostSay();
  farfree( foo );
  farfree( token );
}


#ifdef _Windows
//------------------------------------------------------------------------------------- WINDOWS

typedef struct {
    HWND   hwndSource;
    HANDLE h1;
    WORD   wFlags;
    HANDLE hList;
    HANDLE hOfstruct;
    int    x, y;
    long   lUnknown;
    } DRAGINFO, FAR *LPDRAGINFO;

void DoEvents( void )
{
  MSG msg;

	while (PeekMessage(&msg, (HWND) NULL, 0, 0, PM_REMOVE))
	{
    if (!IsDialogMessage( TopWindow, &msg ))
    {
  		TranslateMessage(&msg);
	  	DispatchMessage(&msg);
    }
	}
}

void CenterWindow( HWND Win )
{
  RECT r;
	int ScreenHeight = GetSystemMetrics( SM_CYSCREEN );
	int ScreenWidth  = GetSystemMetrics( SM_CXSCREEN );
  int WinHeight, WinWidth, NewX, NewY;

	GetWindowRect( Win, &r );
	WinHeight = (r.bottom - r.top);
	WinWidth  = (r.right - r.left);
	NewX = (ScreenWidth - WinWidth) / 2;
	NewY = (ScreenHeight - WinHeight) / 2;

  SetWindowPos( Win, 0, NewX, NewY, 0, 0, SWP_NOSIZE | SWP_NOZORDER ); 
}

void PrepSay( void )
{
  if (TextWindow)
  {
    SendDlgItemMessage( TextWindow, 101, WM_SETTEXT, 0, (LPARAM) "" );
    SendDlgItemMessage( TextWindow, 101, WM_SETREDRAW, FALSE, 0L );
  }
}

void PostSay( void )
{
  if (TextWindow)
  {
    SendDlgItemMessage( TextWindow, 101, WM_SETREDRAW, TRUE, 0L );
    InvalidateRect( GetDlgItem( TextWindow, 101 ), NULL, TRUE );
  }
}

#pragma argsused
BOOL CALLBACK TextWindowProc( HWND dlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch (msg)
	{
		case WM_INITDIALOG :
      DragAcceptFiles( dlg, TRUE );
			CenterWindow( dlg );
			return TRUE;

    case WM_ACTIVATE :
      if (wParam != WA_INACTIVE) TopWindow = dlg;
      return TRUE;   

    case WM_SIZE :
      if (wParam != SIZE_MINIMIZED)
      {
        int x = LOWORD( lParam ), y = HIWORD( lParam );
        HWND lb = GetDlgItem( dlg, 101 ), ok = GetDlgItem( dlg, IDOK );

        SetWindowPos( lb, NULL, 0, 0, x, y-30, SWP_NOACTIVATE | SWP_NOZORDER );
        SetWindowPos( ok, NULL, ((x-60)>>1), y-26, 60, 22, SWP_NOACTIVATE | SWP_NOZORDER);
      }
      return TRUE;

    case WM_DESTROY :
      DragAcceptFiles( dlg, FALSE );
      TextWindow = NULL;
      return TRUE;

		case WM_CLOSE :
      DestroyWindow( dlg );
			return TRUE;

		case WM_COMMAND :
			if (wParam == IDOK) SendMessage( dlg, WM_CLOSE, 0, 0L );
			return TRUE;

    case WM_QUERYDROPOBJECT :
      {
        LPDRAGINFO di = (LPDRAGINFO) lParam;
        return ((di->wFlags & 0x7FFF) == 0x0002) ? 0 : 1;
      }

    case WM_DROPFILES :
      SendMessage( MainWindow, msg, wParam, lParam );
      return TRUE;

		default :
      return FALSE;
	}
}

void say( LPSTR s )
{
  HWND w;
  if (!TextWindow)
  {
    if (!TextProc) TextProc = MakeProcInstance( TextWindowProc, inst );
    TextWindow = CreateDialog( inst, MAKEINTRESOURCE( 3 ), MainWindow, TextProc );
    SendDlgItemMessage( TextWindow, 101, WM_SETREDRAW, FALSE, 0L );
  }
  w = GetDlgItem( TextWindow, 101 );
  SendMessage( w, EM_SETSEL, 1, 0xffffffffL );
  SendMessage( w, EM_REPLACESEL, 0, (LPARAM) s ); 
  SendMessage( w, EM_SETSEL, 1, 0xffffffffL );
  SendMessage( w, EM_REPLACESEL, 0, (LPARAM) "\xd\xa" );
  SendMessage( w, EM_SETSEL, 1, 0xffffffffL );
}

int Usage( void )
{
  MessageBox( NULL,
              "Usage:  geekcode [-ahmt] [{ filename | -c }]\n\n"
              "  -a  Print all potential Geek Codes\n"
              "  -h  Print Geek Code with highest confidence (default)\n\n"
              "  -m  Output in HTML format\n"
              "  -t  Output in plaintext format (default)\n\n"
              "  -c  Use text in Windows clipboard\n\n"
              "With no parameters, runs GeekCode in interactive mode. Select an\n"
              "input source using the controls, or drag-and-drop a file onto the\n"
              "GeekCode window or icon.", "GeekCode Usage", MB_ICONINFORMATION ); 
  return 1;
}

int PrintError( char *foo )
{
  MessageBox( NULL, foo, "GeekCode Error", MB_ICONEXCLAMATION );
  return 1;
}

BOOL OpenInputFile( void )
{
  if (ClipData) farfree( ClipData );
  ClipData = NULL;
  index = 0L;
  if (UseClipboard)
  {
    if (OpenClipboard( MainWindow ))
    {
      HGLOBAL cliphand = NULL;
      int WhichFormat = IsClipboardFormatAvailable( CF_TEXT ) ? CF_TEXT :
                        (IsClipboardFormatAvailable( CF_OEMTEXT ) ? CF_OEMTEXT : 0);
      if (!WhichFormat) return (PrintError( "There is no text data in the Clipboard." ) & 0);

      cliphand = GetClipboardData( WhichFormat );
      if (cliphand)
      {
        LPSTR foo = (LPSTR) GlobalLock( cliphand );
        ClipData = (LPSTR) farmalloc( _fstrlen( foo ) + 1 );
        if (ClipData)
        {
          _fstrcpy( ClipData, foo );
        }
        GlobalUnlock( cliphand );
      }
      CloseClipboard();
      return (ClipData != NULL);
    }
    else return (PrintError( "Unable to open the Clipboard." ) & 0 );
  }
  else
  {
    OFSTRUCT ofs;
    HFILE f = OpenFile( InFileName, &ofs, OF_EXIST );
    long l;
    if (f != HFILE_ERROR)
    {
      f = OpenFile( InFileName, &ofs, OF_READ );
      l = _llseek( f, 0, 2 );
      if (l)
      {
        _llseek( f, 0, 0 );
        ClipData = (LPSTR) farmalloc( l + 1 );
        if (ClipData)
        {
          ClipData[l] = 0;
          _hread( f, (void _huge *) ClipData, l );
          UseClipboard = TRUE;
        } else PrintError( "Unable to allocate memory for input buffer." );
      } else PrintError( "Empty file." );
       _lclose( f );
      return (ClipData != NULL);
    }
    else return (PrintError( "Error opening input file." ) & 0 );
  }
}


BOOL GetNextLine( LPSTR line, int maxlen )
{
  int j = 0;
  if ((!ClipData) || (!ClipData[index])) return FALSE;

  while ((j < maxlen) && (cdi != 13) && (cdi != 10) && (cdi != 0))
    line[j++] = ClipData[index++];
  line[j] = 0;
  if (cdi == 13) index++;
  if (cdi == 10) index++;
  return TRUE;
}

void CloseInputFile( void )
{
  if (ClipData)
  {
    farfree( ClipData );
    ClipData = NULL;
  }
}

void ShowOther( HINSTANCE who )
{
	TASKENTRY te;
  BOOL quit;

	memset( &te, 0, sizeof( TASKENTRY ));
	te.dwSize = sizeof( TASKENTRY );

	quit = !TaskFirst( &te );
	while (!quit)
	{
		if (te.hInst == who)
		{
			PostAppMessage( te.hTask, WM_SHOWWINDOW, -1, -1L );
			quit = TRUE;
    }
    if (!quit) quit = !TaskNext( &te );
	} 
}

#pragma argsused
BOOL CALLBACK AboutProc( HWND dlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch (msg)
	{
		case WM_INITDIALOG :
			CenterWindow( dlg );
			return TRUE;

    case WM_ACTIVATE :
      if (wParam != WA_INACTIVE) TopWindow = dlg;
      return TRUE;   

		case WM_CLOSE :
      EndDialog( dlg, 0 );
			return TRUE;

		case WM_COMMAND :
			if (wParam == IDOK) EndDialog( dlg, 0 );
			return TRUE;

		default :
			return FALSE;
	}
}


BOOL CALLBACK MainWindowProc( HWND dlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
  int NotifyCode = HIWORD( lParam );

	switch (msg)
	{
		case WM_INITDIALOG :
			CenterWindow( dlg );
      DragAcceptFiles( dlg, TRUE );
      CheckDlgButton( dlg, PrintAll ? 105 : 106, TRUE );
      CheckDlgButton( dlg, HTML ? 109 : 108, TRUE );
			return TRUE;

    case WM_ACTIVATE :
      if (wParam != WA_INACTIVE) TopWindow = dlg;
      return TRUE;   

		case WM_CLOSE :
      DragAcceptFiles( dlg, FALSE );
			PostQuitMessage( 0 );
			return TRUE;

		case WM_COMMAND :
			switch (wParam)
			{
        case 101 : // FILE button
          {
            OPENFILENAME ofn;
            UseClipboard = FALSE;
            PrintAll = IsDlgButtonChecked( dlg, 105 );
            HTML = IsDlgButtonChecked( dlg, 109 );
            InFileName[0] = 0;
            _fmemset( &ofn, 0, sizeof( OPENFILENAME ));
            ofn.lStructSize = sizeof( OPENFILENAME );
            ofn.hwndOwner = dlg;
            ofn.hInstance = inst;
            ofn.lpstrFilter = "Text files (*.txt)\x0*.txt\x0""All files (*.*)\x0*.*\x0\x0";
            ofn.lpstrFile = InFileName;
            ofn.nMaxFile = 144;
            ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_PATHMUSTEXIST;
            if (GetOpenFileName( &ofn ))
            {
              if (OpenInputFile())
              {
                GoToTown();
                CloseInputFile();
              }
            }
          }
          return TRUE;

        case 102 : // CLIPBOARD button
          UseClipboard = TRUE;
          PrintAll = IsDlgButtonChecked( dlg, 105 );
          HTML = IsDlgButtonChecked( dlg, 109 );
          InFileName[0] = 0;
          if (OpenInputFile())
          {
            GoToTown();
            CloseInputFile();
          }
          return TRUE;

        case 103 : // HELP button
          HelpCalled = WinHelp( MainWindow, "GeekCode.hlp", HELP_CONTENTS, 0L );
          return TRUE;

        case 104 : // ABOUT button
          {
            DLGPROC about = MakeProcInstance( AboutProc, inst );
            DialogBox( inst, MAKEINTRESOURCE( 2 ), dlg, about );
            FreeProcInstance( about );
          }
          return TRUE;

				case 107 : // EXIT button
					if (NotifyCode == BN_CLICKED)
            SendMessage( dlg, WM_CLOSE, 0, 0L );
					break;

        case 105 : // Print All Codes radio button
          if (IsDlgButtonChecked( dlg, 109 ))
          {
            HTML = FALSE;
            CheckRadioButton( dlg, 108, 109, 108 );
          }
          break;

        case 109 : // HTML radio button
          if (IsDlgButtonChecked( dlg, 105 ))
          {
            PrintAll = FALSE;
            CheckRadioButton( dlg, 105, 106, 106 );
          }
          break;
      }
			return TRUE;

    case WM_QUERYDROPOBJECT :
      {
        LPDRAGINFO di = (LPDRAGINFO) lParam;
        return ((di->wFlags & 0x7FFF) == 0x0002) ? 0 : 1;
      }

    case WM_DROPFILES :
      {
        HDROP hDrop = (HDROP) wParam;
        LPSTR foo = (LPSTR) farmalloc( 144 );

        DragQueryFile( hDrop, 0, foo, 144 );
        DragFinish( hDrop );
        if (foo[0])
        {
          _fstrcpy( InFileName, foo );
          UseClipboard = FALSE;
          PrintAll = IsDlgButtonChecked( dlg, 105 );
          HTML = IsDlgButtonChecked( dlg, 109 );
          if (OpenInputFile())
          {
            GoToTown();
            CloseInputFile();
          }
        }
        farfree( foo );
      }
      return TRUE;

		default :
			return FALSE;
	}
}

void RegisterNewClasses( void )
{
	WNDCLASS wc;

	wc.style         = 0;
	wc.lpfnWndProc   = DefDlgProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = DLGWINDOWEXTRA;
	wc.hInstance     = inst;
	wc.hIcon         = MainIcon = LoadIcon(inst, MAKEINTRESOURCE( 1 ));
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wc.lpszMenuName  = NULL;
  wc.lpszClassName = "clsGeekCode";
	RegisterClass(&wc);

  wc.lpszClassName = "clsGeekInterpreted";
	RegisterClass(&wc);

}

void ShowSelf( int CmdShow )
{
  MSG msg;
  DLGPROC MainProc = MakeProcInstance( MainWindowProc, inst );
	HMENU SysMenu;

  RegisterNewClasses();
	MainWindow = CreateDialog( inst, MAKEINTRESOURCE( 1 ), NULL, MainProc );
  SysMenu = GetSystemMenu( MainWindow, FALSE );
	DeleteMenu( SysMenu, SC_SIZE, MF_BYCOMMAND );
	DeleteMenu( SysMenu, SC_MAXIMIZE, MF_BYCOMMAND );
	ShowWindow( MainWindow, CmdShow );

	while (GetMessage(&msg, (HWND) NULL, 0, 0))
	{
		if ((msg.hwnd == NULL) && (msg.message == WM_SHOWWINDOW))
		{
      ShowWindow( MainWindow, SW_SHOWNORMAL );
		}
		else 
		{
      if (!IsDialogMessage( TopWindow, &msg ))
      {
        TranslateMessage(&msg);
			  DispatchMessage(&msg);
      }
		}
	}
  if (HelpCalled) WinHelp( MainWindow, "GeekCode.hlp", HELP_QUIT, 0L );
  if (TextWindow) DestroyWindow( TextWindow );
  if (TextProc) FreeProcInstance( TextProc );
	DestroyWindow( MainWindow );
  UnregisterClass( "clsGeekCode", inst );
  UnregisterClass( "clsGeekInterpreted", inst );
  DeleteObject( MainIcon );
	FreeProcInstance( MainProc );
}

#pragma warn -par
int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	inst = hInstance;

	if (hPrevInstance)
		ShowOther( hPrevInstance );
	else
		ShowSelf( nCmdShow );
  return 0;
}
#pragma warn .par

#else
//----------------------------------------------------------------------------------------- DOS


int WindowsRunning( void )
{
	struct REGPACK r;

	r.r_ax = 0x352f;
	intr( 0x21, &r );
	if ((r.r_es | r.r_bx) == 0) return 0;

	r.r_ax = 0x4680;
	intr( 0x2f, &r );
	if ((r.r_ax & 0x00ff) == 0) return 2;

	r.r_ax = 0x1600;
	intr( 0x2f, &r );
	return ((r.r_ax & 0x007f) == 0) ? 0 : 3;
}

int WinOldAp( void )
{
	struct REGPACK r;

	r.r_ax = 0x1700;
	intr( 0x2f, &r );
  if (r.r_ax == 0x1700) return 0;
  return r.r_ax;
}

int OpenClipboard( void )
{
	struct REGPACK r;
	r.r_ax = 0x1701;
	intr( 0x2f, &r );
  return (r.r_ax != 0);
}

int IsClipboardFormatAvailable( int format )
{
	struct REGPACK r;

	r.r_ax = 0x1704;
	r.r_dx = format;
  intr( 0x2f, &r );
  return ((r.r_ax | r.r_dx) != 0);
}

long GetClipboardDataSize( int format )
{
	struct REGPACK r;
  long l;

	r.r_ax = 0x1704;
	r.r_dx = format;
  intr( 0x2f, &r );

	l = r.r_dx;
	l <<= 16;
  l |= r.r_ax;
  return l;
}

void far *GetClipboardData( int format )
{
	struct REGPACK r;
	void far *temp;
	long l = GetClipboardDataSize( format );

	if (!l) return (void far *) (PrintError( "Empty string in Clipboard!" ) & 0);
  temp = farmalloc( l );
  if (!temp) return (void far *) (PrintError( "Unable to allocate memory for data in Clipboard!" ) & 0);

  r.r_ax = 0x1705;
	r.r_dx = format;
	r.r_bx = (unsigned int) ((long) temp & 0xffff);
	r.r_es = (unsigned int) (((long) temp & 0xffff0000) >> 16);
	intr( 0x2f, &r );
	if (r.r_ax == 0)
	{
		farfree( temp );
    temp = NULL;
	}
  if (!temp) PrintError( "Unable to copy data out of Clipboard!" );
  return temp;
} 

int CloseClipboard( void )
{
	struct REGPACK r;

	r.r_ax = 0x1708;
	intr( 0x2f, &r );
  return (r.r_ax != 0);
}

BOOL CanReadClipboard( void )
{
  BOOL result;
	if ((!WindowsRunning()) || (!WinOldAp())) return FALSE;
  if (!OpenClipboard()) return FALSE;
  result = (IsClipboardFormatAvailable( CF_OEMTEXT ) || IsClipboardFormatAvailable( CF_TEXT ));
  CloseClipboard();
  return result;
}

int Usage( void )
{
	fprintf( stderr, "GeekCode for DOS v" VERSION " * by Jeff Lee\n\n" );
  if (WindowsRunning())
  {
    fprintf( stderr, "Usage:  geekcode [-achmntw] [{ filename | -c }]\n\n"
                     "  -a  Print all potential Geek Codes\n"
                     "  -h  Print Geek Code with highest confidence (default)\n\n"
                     "  -m  Output in HTML format\n"
                     "  -t  Output in plaintext format (default)\n\n"
                     "  -n  Do not wrap text\n"
                     "  -w  Wrap text to 72 columns (default)\n\n"
                     "  -c  Use Windows Clipboard as input source" );
    if (!CanReadClipboard())
      fprintf( stderr, "      (currently no text in Clipboard)\n" );
    fprintf( stderr, "\n\n" );
  }
  else
    fprintf( stderr, "Usage:  geekcode [-achmntw] [{ filename | -c }]\n\n"
                     "  -a  Print all potential Geek Codes\n"
                     "  -h  Print Geek Code with highest confidence (default)\n\n"
                     "  -m  Output in HTML format\n"
                     "  -t  Output in plaintext format (default)\n\n"
                     "  -n  Do not wrap text\n"
                     "  -w  Wrap text to 72 columns (default)\n\n" );

  fprintf( stderr, "With no parameters, GeekCode parses standard input.\n" );
  return 1;
}

int PrintError( char *foo )
{
  fprintf( stderr, "GeekCode error: %s\n", foo );
  return 1; 
}

BOOL OpenInputFile( void )
{
  index = 0L;
  if (UseClipboard)
  {
    if (ClipData)
    {
      farfree( ClipData );
      ClipData = NULL;
    }
    if (OpenClipboard())
    {
      int WhichFormat = IsClipboardFormatAvailable( CF_OEMTEXT ) ? CF_OEMTEXT :
                        (IsClipboardFormatAvailable( CF_TEXT ) ? CF_TEXT : 0);
      if (WhichFormat) ClipData = GetClipboardData( WhichFormat );
      CloseClipboard();
      if (!WhichFormat) return (PrintError( "No text in Windows Clipboard." ) & 0);
      return (ClipData != NULL);
    }
    else return (PrintError( "Unable to open Windows Clipboard." ) & 0);
  }
  else
  {
    if (InFileName[0])
    {
      infile = fopen( InFileName, "rt" );
      if (!infile) PrintError( "Unable to open input file." );
      return (infile != NULL);
    }
    else return (UseStdin == TRUE);
  }
}

void CloseInputFile( void )
{
  if (infile) fclose( infile );
  if (ClipData) farfree( ClipData );
  ClipData = NULL;
  infile = NULL;
}

BOOL GetNextLine( LPSTR line, int maxlen )
{
  if (UseClipboard)
  {
    int j = 0;
    if (!ClipData[index]) return FALSE;

    while ((j < maxlen) && (cdi != 13) && (cdi != 10) && (cdi != 0))
      line[j++] = ClipData[index++];
    line[j] = 0;
    if (cdi == 13) index++;
    if (cdi == 10) index++;
    return TRUE;
  }
  else
  {
    char *inpbuf = (char *) malloc( maxlen+10 );
    char *retval = fgets( inpbuf, maxlen, UseStdin ? stdin : infile );
    int i;

    if (retval)
    {
      i = strlen( inpbuf );
      if (inpbuf[i-1] == '\n') inpbuf[i-1] = 0;
      _fstrcpy( line, inpbuf );
    }
    free( inpbuf );
    return retval != NULL;
  }
}


void PrepSay( void )
{
  /* Do nothing -- this is just a placeholder in the DOS code. */
}

void PostSay( void )
{
  /* Do nothing -- this is just a placeholder in the DOS code. */
}

void DoEvents( void )
{
  /* Do nothing -- this is just a placeholder in the DOS code. */
}


void say( LPSTR what )
{
  char temp[81];
  int  i = 0, j = 0, index = 0;
  LPSTR fixed = farmalloc( _fstrlen( what ) + 1 );

  while (what[i])
  {
    if (what[i] != 13) fixed[j++] = what[i];
    i++;
  }
  fixed[j] = 0;
  _fstrcpy( what, fixed );

  i = _fstrlen( what ) - 1;
  while (what[i] == ' ') what[i--] = 0;

  if (WrapText && (NotHeader))
  {
    do
    {
      if (_fstrlen( &what[index] ) > 72)
      {
        _fmemcpy( &temp[0], &what[index], 72 );
        temp[72] = 0;
        i = 79;
        while (temp[i] != ' ') i--;
        temp[i] = 0;
        index += strlen( temp );
        while (what[index] == 32) index++;
      }
      else
      {
        _fstrcpy( &temp[0], &what[index] );
        index += strlen( temp );
      }
      printf( "%s\n", temp );
      if ((what[index]) && (HTML)) printf( "    " );
    } while (what[index]);
  } else printf( "%Fs\n", what );
}

int main()
{
  if (!ParseArgs()) return Usage();
  if ((HTML) && (PrintAll)) return PrintError( "-a and -m are incompatible arguments." );
  if ((UseClipboard) && (!WindowsRunning())) return PrintError( "Windows is not running; unable to access Clipboard." );
  if ((UseClipboard) && (!CanReadClipboard())) return PrintError( "No text in Windows Clipboard." );
  if (!OpenInputFile()) return 1;
  GoToTown();
  CloseInputFile();
  return 0;
}

#endif
